mod chain_simulator;
mod memtree_driver;
mod memtree_wrapper;
mod myrand;
mod utxo_store;

use crate::chain_simulator::ChainSimulator;
use crate::memtree_driver::MemTreeSink;

fn run_with_memtree(n: u32) {
    println!("\n\nSimulating with Rustreexo MemTree, n {}", n);

    let sink = Box::new(MemTreeSink::new());
    let mut simul = ChainSimulator::new(sink, 1);
    simul.run(n);

    assert_eq!(simul.tip_height(), n);
    simul.print(false);
}

fn main() {
    println!("UTreeXo Simulator");

    run_with_memtree(500);
}
