use hex_conservative::prelude::*;
use rustreexo::accumulator::mem_forest::MemForest;
use rustreexo::accumulator::node_hash::BitcoinNodeHash as NodeHash;
use rustreexo::accumulator::proof::Proof;

pub struct MemTreeWrapper {
    w: MemForest,
}

impl MemTreeWrapper {
    pub fn new() -> Self {
        Self {
            w: MemForest::new(),
        }
    }

    pub fn modify(&mut self, utxos: &[NodeHash], del_hashes: &[NodeHash]) -> Result<(), String> {
        println!(
            "Pollar: modify, del {} add {}",
            del_hashes.len(),
            utxos.len()
        );
        for i in del_hashes.iter() {
            println!("  i {}", i.to_lower_hex_string())
        }
        for o in utxos.iter() {
            println!("  o {}", o.to_lower_hex_string())
        }

        self.w.modify(utxos, del_hashes)
    }

    pub fn prove(&self, targets: &[NodeHash]) -> Result<Proof, String> {
        println!("Pollar: prove {}", targets.len(),);
        for i in targets.iter() {
            println!("  i {}", i.to_lower_hex_string())
        }

        self.w.prove(targets)
    }
}
